#include "arraystate.h"
#include "bufferstate.h"
#include "enums.h"
#include "strformat.h"

using namespace std;

ArrayState::ArrayState():
	kind(0),
	index(0),
	enabled(false),
	size(4),
	type(GL_FLOAT),
	normalized(false),
	stride(0),
	buffer(0),
	pointer(0)
{ }

void ArrayState::set(unsigned s, GLenum t, bool n, unsigned r, BufferState *b, long p)
{
	size = s;
	type = t;
	stride = r;
	normalized = n;
	buffer = b;
	pointer = p;

	if(buffer)
		buffer->content.update(*this);
}

string ArrayState::describe() const
{
	if(enabled)
	{
		string descr = strformat("%d %s, stride %d", size, describe_enum(type, "DataType"), stride);
		if(buffer)
			descr += strformat(", buffer %d at %d", buffer->id, pointer);
		else
			descr += strformat(", at 0x%X", pointer);
		return descr;
	}
	else
		return "Disabled";
}
