#ifndef INSPECTOR_H_
#define INSPECTOR_H_

#include "glstate.h"
#include "tool.h"

class Inspector: public RegisteredTool<Inspector>
{
private:
	GlDbg &gldbg;
	GlState state;
	GlDecoder *decoder;
	int query_state;

public:
	Inspector(GlDbg &);

	virtual void decode(const char *, unsigned);
	virtual void process_started();
	virtual void process_stopped(int);

private:
	static void gldBreak(void *, unsigned short, unsigned char);

	void print_indented(const std::string &, unsigned);

	void cmd_state(const std::string &);
	void cmd_texture(const std::string &);
	void cmd_buffer(const std::string &);
	void cmd_shader(const std::string &);
	void cmd_program(const std::string &);
};

#endif
